# This file was generated by the Julia Swagger Code Generator
# Do not modify this file directly. Modify the swagger specification instead.

struct SshPublicKeysApi <: SwaggerApi
    client::Swagger.Client
end

"""

Creates a new SSH public key resource.
Param: resourceGroupName::String (required)
Param: sshPublicKeyName::String (required)
Param: parameters::SshPublicKeyResource (required)
Param: api_version::String (required)
Param: subscriptionId::String (required)
Return: SshPublicKeyResource
"""
function sshPublicKeysCreate(_api::SshPublicKeysApi, resourceGroupName::String, sshPublicKeyName::String, parameters, api_version::String, subscriptionId::String; _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "PUT", SshPublicKeyResource, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/sshPublicKeys/{sshPublicKeyName}", ["azure_auth"], parameters)
    Swagger.set_param(_ctx.path, "resourceGroupName", resourceGroupName)  # type String
    Swagger.set_param(_ctx.path, "sshPublicKeyName", sshPublicKeyName)  # type String
    Swagger.set_param(_ctx.path, "subscriptionId", subscriptionId)  # type String
    Swagger.set_param(_ctx.query, "api-version", api_version)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json"] : [_mediaType])
    Swagger.exec(_ctx)
end

"""

Delete an SSH public key.
Param: resourceGroupName::String (required)
Param: sshPublicKeyName::String (required)
Param: api_version::String (required)
Param: subscriptionId::String (required)
Return: Nothing
"""
function sshPublicKeysDelete(_api::SshPublicKeysApi, resourceGroupName::String, sshPublicKeyName::String, api_version::String, subscriptionId::String; _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "DELETE", Nothing, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/sshPublicKeys/{sshPublicKeyName}", ["azure_auth"])
    Swagger.set_param(_ctx.path, "resourceGroupName", resourceGroupName)  # type String
    Swagger.set_param(_ctx.path, "sshPublicKeyName", sshPublicKeyName)  # type String
    Swagger.set_param(_ctx.path, "subscriptionId", subscriptionId)  # type String
    Swagger.set_param(_ctx.query, "api-version", api_version)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json"] : [_mediaType])
    Swagger.exec(_ctx)
end

"""

Generates and returns a public/private key pair and populates the SSH public key resource with the public key. The length of the key will be 3072 bits. This operation can only be performed once per SSH public key resource.
Param: resourceGroupName::String (required)
Param: sshPublicKeyName::String (required)
Param: api_version::String (required)
Param: subscriptionId::String (required)
Return: SshPublicKeyGenerateKeyPairResult
"""
function sshPublicKeysGenerateKeyPair(_api::SshPublicKeysApi, resourceGroupName::String, sshPublicKeyName::String, api_version::String, subscriptionId::String; _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "POST", SshPublicKeyGenerateKeyPairResult, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/sshPublicKeys/{sshPublicKeyName}/generateKeyPair", ["azure_auth"])
    Swagger.set_param(_ctx.path, "resourceGroupName", resourceGroupName)  # type String
    Swagger.set_param(_ctx.path, "sshPublicKeyName", sshPublicKeyName)  # type String
    Swagger.set_param(_ctx.path, "subscriptionId", subscriptionId)  # type String
    Swagger.set_param(_ctx.query, "api-version", api_version)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json"] : [_mediaType])
    Swagger.exec(_ctx)
end

"""

Retrieves information about an SSH public key.
Param: resourceGroupName::String (required)
Param: sshPublicKeyName::String (required)
Param: api_version::String (required)
Param: subscriptionId::String (required)
Return: SshPublicKeyResource
"""
function sshPublicKeysGet(_api::SshPublicKeysApi, resourceGroupName::String, sshPublicKeyName::String, api_version::String, subscriptionId::String; _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "GET", SshPublicKeyResource, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/sshPublicKeys/{sshPublicKeyName}", ["azure_auth"])
    Swagger.set_param(_ctx.path, "resourceGroupName", resourceGroupName)  # type String
    Swagger.set_param(_ctx.path, "sshPublicKeyName", sshPublicKeyName)  # type String
    Swagger.set_param(_ctx.path, "subscriptionId", subscriptionId)  # type String
    Swagger.set_param(_ctx.query, "api-version", api_version)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json"] : [_mediaType])
    Swagger.exec(_ctx)
end

"""

Lists all of the SSH public keys in the specified resource group. Use the nextLink property in the response to get the next page of SSH public keys.
Param: resourceGroupName::String (required)
Param: api_version::String (required)
Param: subscriptionId::String (required)
Return: SshPublicKeysGroupListResult
"""
function sshPublicKeysListByResourceGroup(_api::SshPublicKeysApi, resourceGroupName::String, api_version::String, subscriptionId::String; _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "GET", SshPublicKeysGroupListResult, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/sshPublicKeys", ["azure_auth"])
    Swagger.set_param(_ctx.path, "resourceGroupName", resourceGroupName)  # type String
    Swagger.set_param(_ctx.path, "subscriptionId", subscriptionId)  # type String
    Swagger.set_param(_ctx.query, "api-version", api_version)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json"] : [_mediaType])
    Swagger.exec(_ctx)
end

"""

Lists all of the SSH public keys in the subscription. Use the nextLink property in the response to get the next page of SSH public keys.
Param: api_version::String (required)
Param: subscriptionId::String (required)
Return: SshPublicKeysGroupListResult
"""
function sshPublicKeysListBySubscription(_api::SshPublicKeysApi, api_version::String, subscriptionId::String; _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "GET", SshPublicKeysGroupListResult, "/subscriptions/{subscriptionId}/providers/Microsoft.Compute/sshPublicKeys", ["azure_auth"])
    Swagger.set_param(_ctx.path, "subscriptionId", subscriptionId)  # type String
    Swagger.set_param(_ctx.query, "api-version", api_version)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json"] : [_mediaType])
    Swagger.exec(_ctx)
end

"""

Updates a new SSH public key resource.
Param: resourceGroupName::String (required)
Param: sshPublicKeyName::String (required)
Param: parameters::SshPublicKeyUpdateResource (required)
Param: api_version::String (required)
Param: subscriptionId::String (required)
Return: SshPublicKeyResource
"""
function sshPublicKeysUpdate(_api::SshPublicKeysApi, resourceGroupName::String, sshPublicKeyName::String, parameters, api_version::String, subscriptionId::String; _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "PATCH", SshPublicKeyResource, "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/sshPublicKeys/{sshPublicKeyName}", ["azure_auth"], parameters)
    Swagger.set_param(_ctx.path, "resourceGroupName", resourceGroupName)  # type String
    Swagger.set_param(_ctx.path, "sshPublicKeyName", sshPublicKeyName)  # type String
    Swagger.set_param(_ctx.path, "subscriptionId", subscriptionId)  # type String
    Swagger.set_param(_ctx.query, "api-version", api_version)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json"] : [_mediaType])
    Swagger.exec(_ctx)
end

export sshPublicKeysCreate, sshPublicKeysDelete, sshPublicKeysGenerateKeyPair, sshPublicKeysGet, sshPublicKeysListByResourceGroup, sshPublicKeysListBySubscription, sshPublicKeysUpdate
