# This file was generated by the Julia Swagger Code Generator
# Do not modify this file directly. Modify the swagger specification instead.

struct PolicyDefinitionsApi <: SwaggerApi
    client::Swagger.Client
end

"""
Creates or updates a policy definition in a subscription.
This operation creates or updates a policy definition in the given subscription with the given name.
Param: policyDefinitionName::String (required)
Param: parameters::PolicyDefinition (required)
Param: api_version::String (required)
Param: subscriptionId::String (required)
Return: PolicyDefinition
"""
function policyDefinitionsCreateOrUpdate(_api::PolicyDefinitionsApi, policyDefinitionName::String, parameters, api_version::String, subscriptionId::String; _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "PUT", PolicyDefinition, "/subscriptions/{subscriptionId}/providers/Microsoft.Authorization/policyDefinitions/{policyDefinitionName}", ["azure_auth"], parameters)
    Swagger.set_param(_ctx.path, "policyDefinitionName", policyDefinitionName)  # type String
    Swagger.set_param(_ctx.path, "subscriptionId", subscriptionId)  # type String
    Swagger.set_param(_ctx.query, "api-version", api_version)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json"] : [_mediaType])
    Swagger.exec(_ctx)
end

"""
Creates or updates a policy definition in a management group.
This operation creates or updates a policy definition in the given management group with the given name.
Param: policyDefinitionName::String (required)
Param: parameters::PolicyDefinition (required)
Param: api_version::String (required)
Param: managementGroupId::String (required)
Return: PolicyDefinition
"""
function policyDefinitionsCreateOrUpdateAtManagementGroup(_api::PolicyDefinitionsApi, policyDefinitionName::String, parameters, api_version::String, managementGroupId::String; _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "PUT", PolicyDefinition, "/providers/Microsoft.Management/managementgroups/{managementGroupId}/providers/Microsoft.Authorization/policyDefinitions/{policyDefinitionName}", ["azure_auth"], parameters)
    Swagger.set_param(_ctx.path, "policyDefinitionName", policyDefinitionName)  # type String
    Swagger.set_param(_ctx.path, "managementGroupId", managementGroupId)  # type String
    Swagger.set_param(_ctx.query, "api-version", api_version)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json"] : [_mediaType])
    Swagger.exec(_ctx)
end

"""
Deletes a policy definition in a subscription.
This operation deletes the policy definition in the given subscription with the given name.
Param: policyDefinitionName::String (required)
Param: api_version::String (required)
Param: subscriptionId::String (required)
Return: Nothing
"""
function policyDefinitionsDelete(_api::PolicyDefinitionsApi, policyDefinitionName::String, api_version::String, subscriptionId::String; _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "DELETE", Nothing, "/subscriptions/{subscriptionId}/providers/Microsoft.Authorization/policyDefinitions/{policyDefinitionName}", ["azure_auth"])
    Swagger.set_param(_ctx.path, "policyDefinitionName", policyDefinitionName)  # type String
    Swagger.set_param(_ctx.path, "subscriptionId", subscriptionId)  # type String
    Swagger.set_param(_ctx.query, "api-version", api_version)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json"] : [_mediaType])
    Swagger.exec(_ctx)
end

"""
Deletes a policy definition in a management group.
This operation deletes the policy definition in the given management group with the given name.
Param: policyDefinitionName::String (required)
Param: api_version::String (required)
Param: managementGroupId::String (required)
Return: Nothing
"""
function policyDefinitionsDeleteAtManagementGroup(_api::PolicyDefinitionsApi, policyDefinitionName::String, api_version::String, managementGroupId::String; _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "DELETE", Nothing, "/providers/Microsoft.Management/managementgroups/{managementGroupId}/providers/Microsoft.Authorization/policyDefinitions/{policyDefinitionName}", ["azure_auth"])
    Swagger.set_param(_ctx.path, "policyDefinitionName", policyDefinitionName)  # type String
    Swagger.set_param(_ctx.path, "managementGroupId", managementGroupId)  # type String
    Swagger.set_param(_ctx.query, "api-version", api_version)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json"] : [_mediaType])
    Swagger.exec(_ctx)
end

"""
Retrieves a policy definition in a subscription.
This operation retrieves the policy definition in the given subscription with the given name.
Param: policyDefinitionName::String (required)
Param: api_version::String (required)
Param: subscriptionId::String (required)
Return: PolicyDefinition
"""
function policyDefinitionsGet(_api::PolicyDefinitionsApi, policyDefinitionName::String, api_version::String, subscriptionId::String; _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "GET", PolicyDefinition, "/subscriptions/{subscriptionId}/providers/Microsoft.Authorization/policyDefinitions/{policyDefinitionName}", ["azure_auth"])
    Swagger.set_param(_ctx.path, "policyDefinitionName", policyDefinitionName)  # type String
    Swagger.set_param(_ctx.path, "subscriptionId", subscriptionId)  # type String
    Swagger.set_param(_ctx.query, "api-version", api_version)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json"] : [_mediaType])
    Swagger.exec(_ctx)
end

"""
Retrieve a policy definition in a management group.
This operation retrieves the policy definition in the given management group with the given name.
Param: policyDefinitionName::String (required)
Param: api_version::String (required)
Param: managementGroupId::String (required)
Return: PolicyDefinition
"""
function policyDefinitionsGetAtManagementGroup(_api::PolicyDefinitionsApi, policyDefinitionName::String, api_version::String, managementGroupId::String; _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "GET", PolicyDefinition, "/providers/Microsoft.Management/managementgroups/{managementGroupId}/providers/Microsoft.Authorization/policyDefinitions/{policyDefinitionName}", ["azure_auth"])
    Swagger.set_param(_ctx.path, "policyDefinitionName", policyDefinitionName)  # type String
    Swagger.set_param(_ctx.path, "managementGroupId", managementGroupId)  # type String
    Swagger.set_param(_ctx.query, "api-version", api_version)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json"] : [_mediaType])
    Swagger.exec(_ctx)
end

"""
Retrieves a built-in policy definition.
This operation retrieves the built-in policy definition with the given name.
Param: policyDefinitionName::String (required)
Param: api_version::String (required)
Return: PolicyDefinition
"""
function policyDefinitionsGetBuiltIn(_api::PolicyDefinitionsApi, policyDefinitionName::String, api_version::String; _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "GET", PolicyDefinition, "/providers/Microsoft.Authorization/policyDefinitions/{policyDefinitionName}", ["azure_auth"])
    Swagger.set_param(_ctx.path, "policyDefinitionName", policyDefinitionName)  # type String
    Swagger.set_param(_ctx.query, "api-version", api_version)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json"] : [_mediaType])
    Swagger.exec(_ctx)
end

"""
Retrieves policy definitions in a subscription
This operation retrieves a list of all the policy definitions in a given subscription.
Param: api_version::String (required)
Param: subscriptionId::String (required)
Return: PolicyDefinitionListResult
"""
function policyDefinitionsList(_api::PolicyDefinitionsApi, api_version::String, subscriptionId::String; _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "GET", PolicyDefinitionListResult, "/subscriptions/{subscriptionId}/providers/Microsoft.Authorization/policyDefinitions", ["azure_auth"])
    Swagger.set_param(_ctx.path, "subscriptionId", subscriptionId)  # type String
    Swagger.set_param(_ctx.query, "api-version", api_version)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json"] : [_mediaType])
    Swagger.exec(_ctx)
end

"""
Retrieve built-in policy definitions
This operation retrieves a list of all the built-in policy definitions.
Param: api_version::String (required)
Return: PolicyDefinitionListResult
"""
function policyDefinitionsListBuiltIn(_api::PolicyDefinitionsApi, api_version::String; _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "GET", PolicyDefinitionListResult, "/providers/Microsoft.Authorization/policyDefinitions", ["azure_auth"])
    Swagger.set_param(_ctx.query, "api-version", api_version)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json"] : [_mediaType])
    Swagger.exec(_ctx)
end

"""
Retrieve policy definitions in a management group
This operation retrieves a list of all the policy definitions in a given management group.
Param: api_version::String (required)
Param: managementGroupId::String (required)
Return: PolicyDefinitionListResult
"""
function policyDefinitionsListByManagementGroup(_api::PolicyDefinitionsApi, api_version::String, managementGroupId::String; _mediaType=nothing)
    _ctx = Swagger.Ctx(_api.client, "GET", PolicyDefinitionListResult, "/providers/Microsoft.Management/managementgroups/{managementGroupId}/providers/Microsoft.Authorization/policyDefinitions", ["azure_auth"])
    Swagger.set_param(_ctx.path, "managementGroupId", managementGroupId)  # type String
    Swagger.set_param(_ctx.query, "api-version", api_version)  # type String
    Swagger.set_header_accept(_ctx, ["application/json"])
    Swagger.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json"] : [_mediaType])
    Swagger.exec(_ctx)
end

export policyDefinitionsCreateOrUpdate, policyDefinitionsCreateOrUpdateAtManagementGroup, policyDefinitionsDelete, policyDefinitionsDeleteAtManagementGroup, policyDefinitionsGet, policyDefinitionsGetAtManagementGroup, policyDefinitionsGetBuiltIn, policyDefinitionsList, policyDefinitionsListBuiltIn, policyDefinitionsListByManagementGroup
